# Generated by Django 2.2.6 on 2019-11-16 16:43

import castellum.utils.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Address',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('country', models.CharField(max_length=64, verbose_name='Country')),
                ('city', models.CharField(max_length=128, verbose_name='City')),
                ('zip_code', models.CharField(max_length=5, verbose_name='Zip code')),
                ('street', models.CharField(max_length=128, verbose_name='Street')),
                ('house_number', models.CharField(max_length=5, verbose_name='House number')),
                ('additional_information', models.CharField(blank=True, max_length=32, verbose_name='Additional information')),
            ],
            options={
                'verbose_name': 'Address',
                'verbose_name_plural': 'Addresses',
                'ordering': ['country', 'city', 'zip_code', 'street', 'house_number', 'additional_information'],
            },
        ),
        migrations.CreateModel(
            name='Contact',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateField(auto_now_add=True, verbose_name='Created at')),
                ('updated_at', models.DateField(auto_now=True, verbose_name='Updated at')),
                ('pseudonym', models.CharField(default=None, editable=False, max_length=64, unique=True)),
                ('first_name', models.CharField(max_length=64, verbose_name='First name')),
                ('first_name_phonetic', models.CharField(default=None, editable=False, max_length=128)),
                ('last_name', models.CharField(max_length=64, verbose_name='Last name')),
                ('last_name_phonetic', models.CharField(default=None, editable=False, max_length=128)),
                ('title', models.CharField(blank=True, max_length=64, verbose_name='Title')),
                ('gender', models.CharField(choices=[('f', 'female'), ('m', 'male'), ('*', 'diverse')], default='f', max_length=1, verbose_name='Gender')),
                ('date_of_birth', castellum.utils.fields.DateField(blank=True, null=True, verbose_name='Date of birth')),
                ('email', models.EmailField(blank=True, max_length=128, verbose_name='Email')),
                ('phone_number', castellum.utils.fields.PhoneNumberField(blank=True, max_length=32, region=None, verbose_name='Phone number')),
                ('phone_number_alternative', castellum.utils.fields.PhoneNumberField(blank=True, max_length=32, region=None, verbose_name='Phone number alternative')),
                ('preferred_contact_method', models.CharField(blank=True, choices=[('phone', 'phone'), ('email', 'email'), ('postal', 'postal')], max_length=16, verbose_name='Preferred contact method')),
                ('address', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='contacts.Address', verbose_name='Address')),
                ('guardians', models.ManyToManyField(blank=True, related_name='guardian_of', to='contacts.Contact', verbose_name='Guardians')),
            ],
            options={
                'verbose_name': 'Contact',
                'verbose_name_plural': 'Contacts',
                'ordering': ['last_name', 'first_name'],
            },
        ),
    ]
