(function() {
    $$.on(document, 'change', '[name="guardians_pane"]', function() {
        ['self', 'guardians'].forEach(function(id) {
            var pane = document.getElementById('contact-' + id);
            var radio = document.querySelector('[name="guardians_pane"][value="' + id + '"]');
            pane.hidden = !radio.checked;
        });
    });

    $$.on(document, 'submit', '[data-js="contact-completeness"]', function(event) {
        var complete = false;
        if (document.querySelector('[name="guardians_pane"][value="guardians"]').checked) {
            complete = (
                document.querySelector('[name="guardians_remove"]:disabled') ||
                document.querySelector('[name="guardians_add"]:not(:disabled)') ||
                document.querySelector('[data-js="guardians-blocked"]')
            );
        } else {
            complete = (
                document.querySelector('[name="email"]').value ||
                document.querySelector('[name="phone_number"]').value ||
                document.querySelector('[name="street"]').value
            );
        }
        if (!complete) {
            if (!confirm(django.gettext('There is no way to contact this subject. Are you sure you want to save?'))) {
                event.preventDefault();
            }
        }
    });

    var toggleGuardian = function(el, removed) {
        var wrapper = el.closest('[data-js="guardian-wrapper"]');
        var remove = wrapper.querySelector('[data-js="guardian-remove"]');
        var restore = wrapper.querySelector('[data-js="guardian-restore"]');
        var input = wrapper.querySelector('input');

        wrapper.classList.toggle('text-muted', removed);
        remove.hidden = removed;
        restore.hidden = !removed;
        if (input.name === 'guardians_remove') {
            input.disabled = !removed;
        } else {
            input.disabled = removed;
        }
    };

    $$.on(document, 'click', '[data-js="guardian-remove"]', function() {
        toggleGuardian(this, true);
    });

    $$.on(document, 'click', '[data-js="guardian-restore"]', function() {
        toggleGuardian(this, false);
    });

    var addGuardian = function(name, pk) {
        var template = document.getElementById('guardian-template');
        var button = document.querySelector('[data-js="guardian-add"]');

        var wrapper = document.createElement('div');
        wrapper.innerHTML = template.innerHTML.replace(/{pk}/g, pk);
        wrapper.querySelector('label').textContent = name;

        button.before(wrapper.children[0]);
    };

    $$.on(document, 'click', '[data-js="guardian-add"]', function() {
        // copied from django
        var config = 'height=500,width=800,resizable=yes,scrollbars=yes';
        var win = window.open('/subjects/guardians/', 'guardian-add', config);
        win.focus();
    });

    window.closeGuardianPopup = function(win, data) {
        if (data) {
            data = JSON.parse(data);
            addGuardian(data.name, data.pk);
        }
        win.close();
    };

    $$.on(document, 'click', '[data-js="guardian-dismiss"]', function() {
        window.close();
    });

    var use = function() {
        var data = JSON.stringify(this.dataset);
        opener.closeGuardianPopup(window, data);
    };

    $$.on(document, 'click', '[data-js="guardian-use"]', use);
    document.querySelectorAll('[data-js="guardian-use-auto"]').forEach(el => use.call(el));
})();
