# Generated by Django 3.1.7 on 2021-03-16 16:17

from django.db import migrations, models
import django.db.models.deletion


def migrate_data(apps, schema_editor):
    Domain = apps.get_model('pseudonyms', 'Domain')
    Study = apps.get_model('studies', 'Study')
    StudySession = apps.get_model('studies', 'StudySession')
    ContentType = apps.get_model('contenttypes', 'ContentType')

    study_ct = ContentType.objects.get_for_model(Study)
    session_ct = ContentType.objects.get_for_model(StudySession)

    for study in Study.objects.all():
        domain = Domain.objects.get(key=study.domain)
        domain.content_type = study_ct
        domain.object_id = study.id
        domain.save()

    for session in StudySession.objects.all():
        domain = Domain.objects.get(key=session.domain)
        domain.content_type = session_ct
        domain.object_id = session.id
        domain.save()


class Migration(migrations.Migration):

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        ('pseudonyms', '0002_pseudonym_unique_subject_domain'),
        ('studies', '0029_studytag'),
    ]

    operations = [
        migrations.AddField(
            model_name='domain',
            name='content_type',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.contenttype'),
        ),
        migrations.AddField(
            model_name='domain',
            name='object_id',
            field=models.PositiveIntegerField(blank=True, null=True),
        ),
        migrations.RunPython(migrate_data),
    ]
