# Generated by Django 3.1.3 on 2020-11-30 15:02

import castellum.recruitment.models.attributes
import castellum.utils.fields
import django.core.serializers.json
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import parler.fields
import parler.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('subjects', '0001_squashed_0018_subject_slug'),
        ('studies', '0001_squashed_0025_studysession_schedule_id'),
    ]

    operations = [
        migrations.CreateModel(
            name='AttributeCategory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('order', models.IntegerField(default=0)),
            ],
            options={
                'verbose_name': 'Attribute category',
                'verbose_name_plural': 'Attribute categories',
                'ordering': ['order'],
            },
            bases=(castellum.recruitment.models.attributes.ImportMixin, parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='AttributeDescription',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('field_type', models.CharField(choices=[('CharField', 'CharField'), ('ChoiceField', 'ChoiceField'), ('MultipleChoiceField', 'MultipleChoiceField'), ('OrderedChoiceField', 'OrderedChoiceField'), ('IntegerField', 'IntegerField'), ('BooleanField', 'BooleanField'), ('DateField', 'DateField'), ('AgeField', 'AgeField')], max_length=64)),
                ('privacy_level_read', models.PositiveSmallIntegerField(default=0, validators=[django.core.validators.MaxValueValidator(2)])),
                ('privacy_level_write', models.PositiveSmallIntegerField(default=0, validators=[django.core.validators.MaxValueValidator(2)])),
                ('order', models.IntegerField(default=0)),
                ('statistics_rank', models.CharField(blank=True, choices=[('primary', 'primary'), ('secondary', 'secondary')], max_length=16, null=True, unique=True)),
                ('category', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='recruitment.attributecategory')),
            ],
            options={
                'ordering': ['order'],
            },
            bases=(castellum.recruitment.models.attributes.ImportMixin, parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='SubjectFilterGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('study', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.study')),
            ],
        ),
        migrations.CreateModel(
            name='MailBatch',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('datetime', models.DateTimeField(auto_now_add=True, verbose_name='Sent date')),
                ('contacted_size', models.PositiveIntegerField()),
                ('study', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.study', verbose_name='Study')),
            ],
        ),
        migrations.CreateModel(
            name='AttributeChoice',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('order', models.IntegerField(default=0)),
                ('description', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='recruitment.attributedescription')),
            ],
            options={
                'ordering': ['order'],
            },
            bases=(castellum.recruitment.models.attributes.ImportMixin, parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='AttributeDescriptionTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('label', models.CharField(max_length=64)),
                ('_filter_label', models.CharField(blank=True, default='', max_length=64)),
                ('help_text', models.TextField(blank=True, default='')),
                ('master', parler.fields.TranslationsForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='recruitment.attributedescription')),
            ],
            options={
                'verbose_name': 'attribute description Translation',
                'db_table': 'recruitment_attributedescription_translation',
                'db_tablespace': '',
                'managed': True,
                'default_permissions': (),
                'unique_together': {('language_code', 'master')},
            },
            bases=(parler.models.TranslatedFieldsModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='AttributeChoiceTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('label', models.CharField(max_length=64)),
                ('master', parler.fields.TranslationsForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='recruitment.attributechoice')),
            ],
            options={
                'verbose_name': 'attribute choice Translation',
                'db_table': 'recruitment_attributechoice_translation',
                'db_tablespace': '',
                'managed': True,
                'default_permissions': (),
                'unique_together': {('language_code', 'master')},
            },
            bases=(parler.models.TranslatedFieldsModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='AttributeCategoryTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('label', models.CharField(max_length=64)),
                ('master', parler.fields.TranslationsForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='recruitment.attributecategory')),
            ],
            options={
                'verbose_name': 'Attribute category Translation',
                'db_table': 'recruitment_attributecategory_translation',
                'db_tablespace': '',
                'managed': True,
                'default_permissions': (),
                'unique_together': {('language_code', 'master')},
            },
            bases=(parler.models.TranslatedFieldsModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='SubjectFilter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('operator', models.CharField(max_length=64)),
                ('description', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='recruitment.attributedescription')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='recruitment.subjectfiltergroup')),
                ('value', models.JSONField()),
            ],
        ),
        migrations.CreateModel(
            name='Participation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.IntegerField(choices=[(0, 'not contacted'), (1, 'not reached'), (2, 'unsuitable'), (3, 'invited'), (4, 'follow-up scheduled'), (5, 'awaiting response')], default=0, verbose_name='Status of participation')),
                ('exclusion_criteria_checked', models.BooleanField(default=False, verbose_name='Subject may be suitable')),
                ('study', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.study', verbose_name='Study')),
                ('subject', models.ForeignKey(editable=False, on_delete=django.db.models.deletion.CASCADE, to='subjects.subject')),
                ('followup_date', castellum.utils.fields.DateField(blank=True, null=True, verbose_name='Follow-up date')),
                ('followup_time', models.TimeField(blank=True, null=True, verbose_name='Follow-up time')),
                ('created_at', castellum.utils.fields.DateTimeField(auto_now_add=True, verbose_name='Created at')),
                ('updated_at', castellum.utils.fields.DateTimeField(auto_now=True, verbose_name='Updated at')),
                ('attempts', models.IntegerField(default=0, verbose_name='Attempts')),
                ('news_interest', models.IntegerField(choices=[(1, 'not interested'), (2, 'via postal mail'), (3, 'via email')], default=1, verbose_name='Interest in study news')),
            ],
            options={
                'verbose_name': 'Participation',
                'verbose_name_plural': 'Participations',
                'permissions': [('conduct_study', 'Can conduct studies'), ('search_participations', 'Can search for any participation'), ('recruit', 'Can recruit')],
                'unique_together': {('study', 'subject')},
            },
        ),
        migrations.CreateModel(
            name='Appointment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('start', castellum.utils.fields.DateTimeField(verbose_name='Start')),
                ('participation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='recruitment.participation', verbose_name='Participation')),
                ('session', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.studysession', verbose_name='Session')),
                ('show_up', models.SmallIntegerField(choices=[(1, 'show up'), (2, 'late'), (3, 'excused'), (4, 'no show')], default=1, verbose_name='Show up')),
                ('reminded', models.BooleanField(default=False, verbose_name='Reminded')),
            ],
            options={
                'ordering': ['start'],
                'unique_together': {('session', 'participation')},
                'permissions': [('view_current_appointments', 'Can view current appointments')],
                'verbose_name': 'Appointment',
            },
        ),
        migrations.CreateModel(
            name='AttributeSet',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateField(auto_now_add=True, verbose_name='Created at')),
                ('updated_at', models.DateField(auto_now=True, verbose_name='Updated at')),
                ('data', models.JSONField(encoder=django.core.serializers.json.DjangoJSONEncoder)),
                ('subject', models.OneToOneField(editable=False, on_delete=django.db.models.deletion.CASCADE, to='subjects.subject')),
                ('study_type_disinterest', models.ManyToManyField(blank=True, related_name='_attributeset_study_type_disinterest_+', to='studies.StudyType', verbose_name='Does not want to participate in the following study types:')),
                ('onetime_invitation_disinterest', models.BooleanField(default=False, verbose_name='One time invitation')),
            ],
            options={
                'verbose_name': 'Attribute set',
                'verbose_name_plural': 'Attribute sets',
            },
        ),
        migrations.CreateModel(
            name='NewsMailBatch',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('datetime', models.DateTimeField(auto_now_add=True, verbose_name='Sent date')),
                ('contacted_size', models.PositiveIntegerField()),
                ('other_size', models.PositiveIntegerField()),
                ('mail_subject', models.CharField(max_length=128, verbose_name='E-mail subject')),
                ('mail_body', models.TextField(verbose_name='E-mail body')),
                ('study', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.study', verbose_name='Study')),
            ],
            options={
                'abstract': False,
            },
        ),
    ]
