# Generated by Django 3.1.6 on 2021-02-24 17:27

from django.db import migrations, models


def migrate_value(apps, schema_editor):
    MailBatch = apps.get_model('recruitment', 'MailBatch')
    for batch in MailBatch.objects.filter(reminded=True):
        batch.reminded_datetime = batch.datetime
        batch.save()


class Migration(migrations.Migration):

    dependencies = [
        ('recruitment', '0027_mailbatch_reminded'),
    ]

    operations = [
        migrations.AddField(
            model_name='mailbatch',
            name='reminded_datetime',
            field=models.DateTimeField(blank=True, null=True, verbose_name='Reminder date'),
        ),
        migrations.RunPython(migrate_value),
        migrations.RemoveField(
            model_name='mailbatch',
            name='reminded',
        ),
        migrations.RenameField(
            model_name='mailbatch',
            old_name='reminded_datetime',
            new_name='reminded',
        ),
    ]
