# Generated by Django 3.1.7 on 2021-03-15 10:13

from django.db import migrations, models
import django.db.models.deletion


def migrate_data(apps, schema_editor):
    Study = apps.get_model('studies', 'Study')

    for study in Study.objects.exclude(keywords=''):
        if ';' in study.keywords:
            names = study.keywords.split(';')
        else:
            names = study.keywords.split(',')

        for name in names:
            study.studytag_set.create(name=name.strip())


class Migration(migrations.Migration):

    dependencies = [
        ('studies', '0028_studysession_schedule_id_charfield'),
    ]

    operations = [
        migrations.CreateModel(
            name='StudyTag',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=128, verbose_name='Name')),
                ('study', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='studies.study')),
            ],
        ),
        migrations.RunPython(migrate_data),
        migrations.RemoveField(
            model_name='study',
            name='keywords',
        ),
    ]
