# Generated by Django 3.1.3 on 2020-11-30 14:55

import castellum.utils
import castellum.utils.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Subject',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateField(auto_now_add=True, verbose_name='Created at')),
                ('updated_at', models.DateField(auto_now=True, verbose_name='Updated at')),
                ('privacy_level', models.PositiveIntegerField(choices=[(0, '0 (regular)'), (1, '1 (increased)'), (2, '2 (high)')], default=0, verbose_name='Privacy level')),
                ('no_recruitment', models.BooleanField(default=False, verbose_name='Do not contact for recruitment')),
                ('to_be_deleted', models.DateTimeField(blank=True, null=True, verbose_name='To be deleted')),
                ('note_hard_of_hearing', models.BooleanField(default=False, verbose_name='Hard of hearing')),
                ('note_difficult_to_understand', models.BooleanField(default=False, verbose_name='Difficult to understand')),
                ('note_abusive_language', models.BooleanField(default=False, verbose_name='Abusive language')),
                ('not_available_until', castellum.utils.fields.DateTimeField(blank=True, null=True, verbose_name='not available until')),
            ],
            options={
                'verbose_name': 'Subject',
            },
        ),
        migrations.CreateModel(
            name='TimeSlot',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('hour', models.PositiveSmallIntegerField(verbose_name='hour')),
            ],
            options={
                'ordering': ['hour'],
            },
        ),
        migrations.CreateModel(
            name='SubjectNote',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('content', models.CharField(blank=True, max_length=128, verbose_name='Content')),
                ('subject', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='subjects.subject')),
            ],
        ),
        migrations.AddField(
            model_name='subject',
            name='availability_friday',
            field=models.ManyToManyField(blank=True, related_name='_subject_availability_friday_+', to='subjects.TimeSlot', verbose_name='Friday'),
        ),
        migrations.AddField(
            model_name='subject',
            name='availability_monday',
            field=models.ManyToManyField(blank=True, related_name='_subject_availability_monday_+', to='subjects.TimeSlot', verbose_name='Monday'),
        ),
        migrations.AddField(
            model_name='subject',
            name='availability_thursday',
            field=models.ManyToManyField(blank=True, related_name='_subject_availability_thursday_+', to='subjects.TimeSlot', verbose_name='Thursday'),
        ),
        migrations.AddField(
            model_name='subject',
            name='availability_tuesday',
            field=models.ManyToManyField(blank=True, related_name='_subject_availability_tuesday_+', to='subjects.TimeSlot', verbose_name='Tuesday'),
        ),
        migrations.AddField(
            model_name='subject',
            name='availability_wednesday',
            field=models.ManyToManyField(blank=True, related_name='_subject_availability_wednesday_+', to='subjects.TimeSlot', verbose_name='Wednesday'),
        ),
        migrations.AddField(
            model_name='subject',
            name='to_be_deleted_notified',
            field=models.BooleanField(default=False),
        ),
        migrations.RemoveField(
            model_name='subject',
            name='no_recruitment',
        ),
        migrations.AlterField(
            model_name='subject',
            name='to_be_deleted',
            field=models.DateTimeField(blank=True, help_text='All data about this subject should be deleted or fully anonymized. This includes all data in Castellum and all data collected in studies. This option should be used when a subject requests GDPR deletion.', null=True, verbose_name='To be deleted'),
        ),
        migrations.AlterField(
            model_name='subject',
            name='to_be_deleted',
            field=models.DateField(blank=True, help_text='All data about this subject should be deleted or fully anonymized. This includes all data in Castellum and all data collected in studies. This option should be used when a subject requests GDPR deletion.', null=True, verbose_name='To be deleted'),
        ),
        migrations.AddField(
            model_name='subject',
            name='export_requested',
            field=models.DateField(blank=True, help_text='The subject wants to receive an export of all data we have stored about them. This includes all data in Castellum and all data collected in studies. This option should be used when a subject requests GDPR export.', null=True, verbose_name='Export requested'),
        ),
        migrations.CreateModel(
            name='ExportAnswer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateField(auto_now_add=True, verbose_name='Created at')),
                ('created_by', models.CharField(max_length=150, verbose_name='Created by')),
                ('subject', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='subjects.subject')),
            ],
            options={
                'verbose_name': 'Export answer',
            },
        ),
        migrations.AddField(
            model_name='subject',
            name='source',
            field=models.CharField(blank=True, max_length=128, verbose_name='Data source'),
        ),
        migrations.CreateModel(
            name='ConsentDocument',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Created at')),
                ('file', castellum.utils.fields.RestrictedFileField(blank=True, upload_to='consent/', verbose_name='File')),
                ('is_valid', models.BooleanField(default=True, verbose_name='Is valid')),
                ('is_deprecated', models.BooleanField(default=False, verbose_name='Is deprecated')),
            ],
            options={
                'get_latest_by': 'created_at',
            },
        ),
        migrations.CreateModel(
            name='Consent',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('updated_at', models.DateTimeField(auto_now=True, verbose_name='Updated at')),
                ('status', models.CharField(choices=[('waiting', 'Waiting for confirmation'), ('confirmed', 'Confirmed')], max_length=64, verbose_name='Status')),
                ('document', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='subjects.consentdocument')),
                ('subject', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='subjects.subject')),
            ],
            options={
                'verbose_name': 'Consent',
                'get_latest_by': 'document__created_at',
            },
        ),
        migrations.AlterModelOptions(
            name='subject',
            options={'permissions': [('export_subject', 'Can export all data related to a subject')], 'verbose_name': 'Subject'},
        ),
        migrations.AddField(
            model_name='subject',
            name='slug',
            field=models.CharField(default=castellum.utils.uuid_str, max_length=64, unique=True, verbose_name='Slug'),
        ),
    ]
