# Generated by Django 3.1.2 on 2020-10-26 12:04

import django.core.serializers.json
from django.db import migrations, models


def migrate_data(apps, schema_editor):
    AttributeSet = apps.get_model('recruitment', 'AttributeSet')

    for attributeset in AttributeSet.objects.all():
        attributeset.subject.attributes = attributeset.data
        attributeset.subject.onetime_invitation_disinterest = attributeset.onetime_invitation_disinterest
        attributeset.subject.study_type_disinterest.set(attributeset.study_type_disinterest.all())
        attributeset.subject.save()


class Migration(migrations.Migration):

    dependencies = [
        ('studies', '0001_squashed_0025_studysession_schedule_id'),
        ('subjects', '0020_subject_deceased'),
        ('recruitment', '0001_squashed_0021_rename_outcome_to_news'),
    ]

    operations = [
        migrations.AddField(
            model_name='subject',
            name='attributes',
            field=models.JSONField(default={}, encoder=django.core.serializers.json.DjangoJSONEncoder),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name='subject',
            name='onetime_invitation_disinterest',
            field=models.BooleanField(default=False, verbose_name='Does not want to participate in one time invitations'),
        ),
        migrations.AddField(
            model_name='subject',
            name='study_type_disinterest',
            field=models.ManyToManyField(blank=True, related_name='_subject_study_type_disinterest_+', to='studies.StudyType', verbose_name='Does not want to participate in the following study types'),
        ),
        migrations.RunPython(migrate_data),
    ]
